# Class CIM_RouteCalculationService
extends CIM_NetworkService

This is an abstract base class, derived from Service, that represents the route calculation aspects of a system. This class also addresses functions performed by the system when it exchanges routing information. Examining the RouteCalculationService class definition, note that its superclass NetworkService is deprecated. Therefore, NetworkService's properties need not be implemented in an instance of RouteCalculationService. Unfortunately, NetworkService cannot be removed from the object hierarchy without a major Schema release. When/if this occurs, the NetworkService superclass will be removed, and RouteCalculationService will subclass from CIM_Service directly. Also note that there are a large number of additional routing protocols that are not currently modeled. These will be added over time.

### Table of Contents
Hierarchy
Direct Known Subclasses
Class Qualifiers
Class Properties
Class Methods

## Class Hierarchy

CIM_ManagedElement
|
+--CIM_ManagedSystemElement
|
+--CIM_LogicalElement
|
+--CIM_EnabledLogicalElement
|
+--CIM_Service
|
+--CIM_NetworkService
|
+--CIM_RouteCalculationService

## Direct Known Subclasses

CIM_BGPService
CIM_OSPFService

## Class Qualifiers

Name | Data Type | Value
--- | --- | ---
Abstract | boolean | true

Description

string

This is an abstract base class, derived from Service, that represents the route calculation aspects of a system. This class also addresses functions performed by the system when it exchanges routing information. Examining the RouteCalculationService class definition, note that its superclass NetworkService is deprecated. Therefore, NetworkService's properties need not be implemented in an instance of RouteCalculationService. Unfortunately, NetworkService cannot be removed from the object hierarchy without a major Schema release. When/if this occurs, the NetworkService superclass will be removed, and RouteCalculationService will subclass from CIM_Service directly. Also note that there are a large number of additional routing protocols that are not currently modeled. These will be added over time.

UMLPackagePath | string | CIM::Network::RoutingForwarding
Version | string | 2.7.0

## Class Properties

### Local Class Properties

Name | Data Type | Default Value | Qualifiers
--- | --- | --- | ---
Name | Data Type | Value
AlgorithmType | uint16 |
Description | string | This is an enumerated value that defines the routing algorithm used in this route calculation.
ValueMap | string | 0, 1, 2, 3, 4, 5, 6, 7, 8
Values | string | Unknown, RIPv1, RIPv2, OSPFv1, OSPFv2, BGPv1, BGPv2, BGPv3, BGPv4
RouterID | string |
Description | string | The RouterID uniquely identifies the router that is performing the route calculation. It is the highest IP address on the router (or the highest loopback interface, if there is one).

### Inherited Properties

Name | Data Type | Class Origin
--- | --- | ---
Caption | string | CIM_ManagedElement
CommunicationStatus | uint16 | CIM_ManagedSystemElement
CreationClassName | string | CIM_Service
Description | string | CIM_ManagedElement
DetailedStatus | uint16 | CIM_ManagedSystemElement
ElementName | string | CIM_ManagedElement
EnabledDefault | uint16 | CIM_EnabledLogicalElement
EnabledState | uint16 | CIM_EnabledLogicalElement
HealthState | uint16 | CIM_ManagedSystemElement
InstallDate | datetime | CIM_ManagedSystemElement
InstanceID | string | CIM_ManagedElement
Name | string | CIM_Service
OperatingStatus | uint16 | CIM_ManagedSystemElement
OtherEnabledState | string | CIM_EnabledLogicalElement
PrimaryOwnerContact | string | CIM_Service
PrimaryOwnerName | string | CIM_Service
PrimaryStatus | uint16 | CIM_ManagedSystemElement
RequestedState | uint16 | CIM_EnabledLogicalElement
ServiceURL | string | CIM_NetworkService
Started | boolean | CIM_Service
StartMode | string | CIM_Service
Status | string | CIM_ManagedSystemElement
SystemCreationClassName | string | CIM_Service
SystemName | string | CIM_Service
TimeOfLastStateChange | datetime | CIM_EnabledLogicalElement
TransitioningToState | uint16 | CIM_EnabledLogicalElement
AvailableRequestedStates | uint16[] | CIM_EnabledLogicalElement
Keywords | string[] | CIM_NetworkService
OperationalStatus | uint16[] | CIM_ManagedSystemElement
StartupConditions | string[] | CIM_NetworkService
StartupParameters | string[] | CIM_NetworkService
StatusDescriptions | string[] | CIM_ManagedSystemElement

## Class Methods

### Inherited Class Methods

Name | Return Type | Class Origin
--- | --- | ---
RequestStateChange | uint32 | CIM_EnabledLogicalElement
StartService | uint32 | CIM_Service
StopService | uint32 | CIM_Service